Imports MSXML2

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub
    Friend WithEvents txtOrders As System.Windows.Forms.TextBox
    Friend WithEvents btnTotalOrders As System.Windows.Forms.Button
                        
    'Required by the Windows Form Designer
    Private components As System.ComponentModel.Container

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.btnTotalOrders = New System.Windows.Forms.Button()
        Me.txtOrders = New System.Windows.Forms.TextBox()
        Me.SuspendLayout()
        '
        'btnTotalOrders
        '
        Me.btnTotalOrders.Location = New System.Drawing.Point(104, 8)
        Me.btnTotalOrders.Name = "btnTotalOrders"
        Me.btnTotalOrders.Size = New System.Drawing.Size(64, 32)
        Me.btnTotalOrders.TabIndex = 0
        Me.btnTotalOrders.Text = "Total Orders"
        '
        'txtOrders
        '
        Me.txtOrders.Anchor = (((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right)
        Me.txtOrders.Location = New System.Drawing.Point(0, 48)
        Me.txtOrders.Multiline = True
        Me.txtOrders.Name = "txtOrders"
        Me.txtOrders.ScrollBars = System.Windows.Forms.ScrollBars.Both
        Me.txtOrders.Size = New System.Drawing.Size(272, 229)
        Me.txtOrders.TabIndex = 1
        Me.txtOrders.Text = ""
        Me.txtOrders.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(272, 277)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.txtOrders, Me.btnTotalOrders})
        Me.Name = "Form1"
        Me.Text = "SAXEvents"
        Me.ResumeLayout(False)

    End Sub

#End Region

    ' The SAX XML Reader.
    Private m_SaxReader As New SAXXMLReader()

    ' The SAX reader's error handler.
    Private WithEvents m_ErrorHandler As New SAXErrorEvents()

    ' The SAX reader's content handler.
    Private WithEvents m_ContentHandler As New SAXContentEvents()

    ' The current Order's total price so far.
    Private m_OrderTotal As Double

    ' The grand total of all orders.
    Private m_GrandTotal As Double

    ' Process the XML file.
    Private Sub btnTotalOrders_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTotalOrders.Click
        ' Set the SAX XML Reader's content handler.
        m_SaxReader.contentHandler = m_ContentHandler

        ' Set the SAX XML Reader's error handler.
        m_SaxReader.errorHandler = m_ErrorHandler

        ' Clear out any previous results.
        Me.Cursor = Cursors.WaitCursor
        m_GrandTotal = 0
        txtOrders.Text = ""
        Refresh()

        ' Make the SAX reader parse the document.
        Try
            m_SaxReader.parseURL(DataSubdirectory() & "\Orders.xml")
        Catch exc As Exception
            MsgBox("Error parsing file " & DataSubdirectory() & _
                "\Orders.xml" & vbCrLf & exc.Message, _
                MsgBoxStyle.Exclamation Or MsgBoxStyle.OKOnly, _
                "Parse Error")
        End Try

        ' Display the grand total.
        txtOrders.Text = txtOrders.Text & _
            "--------------------" & vbCrLf & _
            "Grand Total: " & Format(m_GrandTotal, "$#,##0.00")
        txtOrders.Focus()
        txtOrders.Select(txtOrders.Text.Length, 0)
        txtOrders.ScrollToCaret()
        Me.Cursor = Cursors.Default
    End Sub

    ' If this is an Order, start a new total.
    ' If this is an Item, add to the new total.
    Private Sub m_ContentHandler_SAXStartElement(ByRef strNamespaceURI As String, ByRef strLocalName As String, ByRef strQName As String, ByVal oAttributes As MSXML2.IVBSAXAttributes) Handles m_ContentHandler.SAXStartElement
        ' See what kind of element this is.
        If strLocalName = "Order" Then
            ' Order.
            ' Start a new total.
            m_OrderTotal = 0
        ElseIf strLocalName = "Item" Then
            ' Item element. 
            ' Add to the current total.
            m_OrderTotal = m_OrderTotal + _
                CDbl(oAttributes.getValueFromName("", "UnitPrice")) * _
                CDbl(oAttributes.getValueFromName("", "Quantity"))
        End If
    End Sub

    ' If this is the end of an Order, add its 
    ' total to the output.
    Private Sub m_ContentHandler_SAXEndElement(ByRef strNamespaceURI As String, ByRef strLocalName As String, ByRef strQName As String) Handles m_ContentHandler.SAXEndElement
        ' See if this is the end of an Order element.
        If strLocalName = "Order" Then
            ' Add the order total to the output text.
            txtOrders.Text = txtOrders.Text & _
                Format(m_OrderTotal, "$#,##0.00") & vbCrLf

            ' Add the order total to the grand total.
            m_GrandTotal = m_GrandTotal + m_OrderTotal
        End If
    End Sub

    ' Report an error.
    Private Sub m_ErrorHandler_SAXFatalError(ByVal oLocator As MSXML2.IVBSAXLocator, ByRef strErrorMessage As String, ByVal nErrorCode As Integer) Handles m_ErrorHandler.SAXFatalError
        MsgBox("Error parsing XML document." & _
            vbCrLf & "Line: " & oLocator.lineNumber & _
            vbCrLf & "Column: " & oLocator.columnNumber, _
            MsgBoxStyle.Information Or MsgBoxStyle.OKOnly, _
            "Parse Error")
    End Sub
End Class
